.386                        ; 80386 requirement
.model flat, stdcall        ; 32-bit code
option casemap:none         ; case sensitive

include windows.inc
include kernel32.inc
include masm32.inc
include shlwapi.inc
include c:\masm32\macros\macros.asm

includelib kernel32.lib
includelib masm32.lib
includelib shlwapi.lib

.data?
num1    dd  ?               ; first input buffer
num2    dd  ?               ; second input buffer
num3    dd  ?               ; "add" result buffer
num4    dd  ?               ; "sub"
num5    dd  ?               ; "imul"
num6    dd  ?               ; "idiv"
num7    dd  ?               ; "idiv" remainder

.code
main:

    print chr$(" Console signed-integer test by MCJ 2005 - press enter to exit.")
begin:
    mov eax, input(13,10,13,10," Enter first number: ") 
    invoke StrToInt,eax     ; convert string to integer
    mov num1, eax           ; copy integer into num1 dword offset
    test eax,eax            ; if any input number is a zero,
    jz bye                  ; exit (divide by zero will crash the app)

    mov eax, input(" Enter second number: ")
    invoke StrToInt,eax     ; invoked results always returned in eax
    mov num2, eax           ; necessary to save values this way because
    test eax,eax            ; StrToInt overwrites eax,ecx, and edx
    jz bye
                            
_add:
    mov ecx, num1           ; load our number VALUES into ecx and
    mov edx, num2           ; edx - see ASMINTRO.HLP about dereferencing
    add ecx, edx            ; add edx to ecx, hex result in ecx
    mov num3, ecx           ; save result in num3 dword offset
    
    print chr$(13,10,"  ADD result: ")
    print str$(num1)
    print chr$(" + ")
    print str$(num2)
    print chr$(" = ")
    print str$(num3)

_sub:
    mov ecx, num1           ; 
    mov edx, num2           ; 
    sub ecx, edx            ; subtract edx from ecx, result in ecx
    mov num4, ecx           ; 
    
    print chr$(13,10,"  SUB result: ")
    print str$(num1)
    print chr$(" - ")
    print str$(num2)
    print chr$(" = ")
    print str$(num4)

_mul:
    mov eax, num1           ; 
    mov edx, num2           ;
    imul eax, edx           ; signed multiply eax & edx, result in eax
    mov num5, eax           ; 
    
    print chr$(13,10," IMUL result: ")
    print str$(num1)
    print chr$(" * ")
    print str$(num2)
    print chr$(" = ")
    print str$(num5)

_div:
    mov eax, num1           ; load registers, imul uses eax
    mov ecx, num2           ;
    mov edx, 0              ; clear edx!
    idiv ecx                ; signed divide eax / ecx
    mov num6, eax           ; save quotient
    mov num7, edx           ; save remainder
    
    print chr$(13,10," IDIV result: ")
    print str$(num1)
    print chr$(" / ")
    print str$(num2)
    print chr$(" = ")
    print str$(num6)
    print chr$(" R: ")
    print str$(num7)

    jmp begin               ; start over

bye:
    invoke ExitProcess,0    ; exit gracefully

end main